package highscoretetrisai.real;

import java.util.*;

public class RNG {
  
  private static final int[] spawnTable 
      = { 0x02, 0x07, 0x08, 0x0A, 0x0B, 0x0E, 0x12 };
  
  private int spawnCount;
  private int spawnID;
  
  public int spawn(final Random random) {
    
    ++spawnCount;
    spawnCount &= 0xFF;
    
    int index = (random.nextInt(256) + spawnCount) & 7;
    
    if (index == 7 || spawnTable[index] == spawnID) {
      index = ((random.nextInt(256) & 7) + spawnID) % 7;
    }
    
    spawnID = spawnTable[index];
    
    return index;
  }
}